/*
   "rm_filter.c" - part of "RAGMAAN, een anagrammengenerator"

   This is a custom filter that replaces some ASCII values that
   Ragmaan cannot handle.

   It is probably specific to "nl.txt" & "woor-den.max", since I 
   only consider the problem cases I encountered in those files.

   Copyright (C) 1999 Raymond Zandbergen

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   The maintainer of this program is Raymond Zandbergen (ray@wirehub.nl)
 */

#include <stdio.h>

int
main (void)
{
  int c;

  while (1)
    {

      c = getchar ();
      if (EOF == c)
	break;
      switch (c)
	{

	case 0x91:
	  putchar ('\'');
	  break;
	case 0xb7:
	  break;
	case 0xdc:
	  putchar ('u');
	  break;
	case 0xe0:
	case 0xe2:
	case 0xe4:
	  putchar ('a');
	  break;
	case 0xe7:
	  putchar ('c');
	  break;
	case 0xe8:
	case 0xe9:
	case 0xea:
	case 0xeb:
	  putchar ('e');
	  break;
	case 0xee:
	case 0xef:
	  putchar ('i');
	  break;
	case 0xf1:
	  putchar ('n');
	  break;
	case 0xf4:
	case 0xf6:
	  putchar ('o');
	  break;
	case 0xfb:
	case 0xfc:
	  putchar ('u');
	  break;
	default:
	  putchar (c);
	}
    }
  return 0;
}
